//+------------------------------------------------------------------+
//|                                                         Kris.mq4 |
//+------------------------------------------------------------------+
//|                                            Indicator Channel.mq4 |
//|                                                      K.Piligrimm |
//|                                             piligrimm_fx@mail.ru |
//+------------------------------------------------------------------+
#property copyright "K.Piligrimm"
#property link      "K.Piligrimm"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Aqua
#property indicator_color2 Yellow
#property indicator_color3 Aqua

//---- input parameters

static datetime time0=0;          

extern int LengthSample=1990;    //      .
extern int Threshold= 20;
extern int SaveFileData= 0;
extern string FileNameData=  "Channel.csv";
extern int Subscripting_MT4= 0;   
extern string NameGlobalVariableUpper_0="Upper_0";
extern string NameGlobalVariableUpper_1="Upper_1";
extern string NameGlobalVariableMedium_0="Medium_0";
extern string NameGlobalVariableMedium_1="Medium_1";
extern string NameGlobalVariableLower_0="Lower_0";
extern string NameGlobalVariableLower_1="Lower_1";              
int mc0=0,k0,k1,Bars1;  
double GV[][3],GM1[],JS0[][2],GM2[],JS1[][2],GM3[],Ex0,Ex1,Ex2,Ex3,Ex4,Ex5,Upper_0,Upper_1,Medium_0,Medium_1,Lower_0,Lower_1; 

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   
    SetIndexStyle(0,DRAW_LINE);
    SetIndexDrawBegin(0,LengthSample);
    SetIndexBuffer(0,ExtMapBuffer1);
    SetIndexStyle(1,DRAW_LINE);
    SetIndexDrawBegin(1,LengthSample);
    SetIndexBuffer(1,ExtMapBuffer2);
    SetIndexStyle(2,DRAW_LINE);
    SetIndexDrawBegin(2,LengthSample);
    SetIndexBuffer(2,ExtMapBuffer3);
    SetIndexStyle(3,DRAW_LINE); 
    
    Ex0=0;Ex1=0;Ex2=0;Ex3=0;Ex4=0;Ex5=0;
    GlobalVariableSet(NameGlobalVariableUpper_0, Ex0);
    GlobalVariableSet(NameGlobalVariableUpper_1, Ex1);
    GlobalVariableSet(NameGlobalVariableMedium_0, Ex2);
    GlobalVariableSet(NameGlobalVariableMedium_1, Ex3);
    GlobalVariableSet(NameGlobalVariableLower_0, Ex4);
    GlobalVariableSet(NameGlobalVariableLower_1, Ex5);      
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
    GlobalVariableDel(NameGlobalVariableUpper_0); 
    GlobalVariableDel(NameGlobalVariableUpper_1);
    GlobalVariableDel(NameGlobalVariableMedium_0); 
    GlobalVariableDel(NameGlobalVariableMedium_1);
    GlobalVariableDel(NameGlobalVariableLower_0); 
    GlobalVariableDel(NameGlobalVariableLower_1);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
    {//0
     
    if(time0 == Time[0]) return(0);  ////////////////////////////////
        time0 = Time[0];              //////////////////////////////// 


    double Mt,MS[3],PIP[2];
    int m,j,i,nn,nt=0,iq,jm,gm1,gm2,handle; 
    Bars1=LengthSample+100;
    ArrayResize(GM1, LengthSample+101);
    ArrayResize(JS0, LengthSample+100);
    ArrayResize(GM2, LengthSample+101);
    ArrayResize(JS1, LengthSample+100); 
    ArrayResize(GM3, LengthSample+101); 
    ArrayResize(GV, LengthSample);
    SetIndexStyle(0, DRAW_LINE,STYLE_SOLID,2);
    SetIndexStyle(1, DRAW_LINE,STYLE_SOLID,2);
    SetIndexStyle(2, DRAW_LINE,STYLE_SOLID,2);
       PIP[1]=Threshold*Point; PIP[0]=NormalizeDouble(PIP[1]/5,Digits);  
            
       JS0[0][0]=High[Bars1];JS0[0][1]=0;     
       JS0[1][0]=High[Bars1-31];JS0[1][1]=30;nt=30;
       k0=1; 
       m=Bars1-1;
     for( nn=nt; nn<Bars1; nn++)
      {//6     
    if ((High[m-nn]-JS0[k0][0])<-PIP[1])  
      {//7
       k0++;   
       JS0[k0][0]=High[m-nn];JS0[k0][1]=nn;
      }//7
    else if ((High[m-nn]-JS0[k0][0])>PIP[1]) 
      {//8
       k0++;
       JS0[k0][0]=High[m-nn];JS0[k0][1]=nn; 
      }//8
    if ((JS0[k0-1][0]>JS0[k0][0])&&((High[m-nn]-JS0[k0][0])<0))
       
      if ((High[m-nn]-JS0[k0-1][0])<-PIP[0])  
      {//9
       k0++;
       JS0[k0][0]=High[m-nn];JS0[k0][1]=nn;
      }//9
    else   
      {//10
       JS0[k0][0]=High[m-nn];JS0[k0][1]=nn; 
      }//10 
    else if ((JS0[k0-1][0]<JS0[k0][0])&&((High[m-nn]-JS0[k0][0])>0))
       
      if ((High[m-nn]-JS0[k0-1][0])>PIP[0]) 
      {//11
       k0++;
       JS0[k0][0]=High[m-nn];JS0[k0][1]=nn; 
      }//11
    else  
      {//12
       JS0[k0][0]=High[m-nn];JS0[k0][1]=nn; 
      }//12   
      }//6
       JS1[0][0]=Low[Bars1];JS1[0][1]=0;     
       JS1[1][0]=Low[Bars1-31];JS1[1][1]=30;nt=30; 
       k1=1; 
       m=Bars1-1;
     for( nn=nt; nn<Bars1; nn++)
      {//6     
    if ((Low[m-nn]-JS1[k1][0])<-PIP[1])  
      {//7
       k1++;   
       JS1[k1][0]=Low[m-nn];JS1[k1][1]=nn;
      }//7
    else if ((Low[m-nn]-JS1[k1][0])>PIP[1]) 
      {//8
       k1++;
       JS1[k1][0]=Low[m-nn];JS1[k1][1]=nn; 
      }//8
    if ((JS1[k1-1][0]>JS1[k1][0])&&((Low[m-nn]-JS1[k1][0])<0))
       
      if ((Low[m-nn]-JS1[k1-1][0])<-PIP[0])  
      {//9
       k1++;
       JS1[k1][0]=Low[m-nn];JS1[k1][1]=nn;
      }//9
    else   
      {//10
       JS1[k1][0]=Low[m-nn];JS1[k1][1]=nn; 
      }//10 
    else if ((JS1[k1-1][0]<JS1[k1][0])&&((Low[m-nn]-JS1[k1][0])>0))
       
      if ((Low[m-nn]-JS1[k1-1][0])>PIP[0]) 
      {//11
       k1++;
       JS1[k1][0]=Low[m-nn];JS1[k1][1]=nn; 
      }//11
    else  
      {//12
       JS1[k1][0]=Low[m-nn];JS1[k1][1]=nn; 
      }//12   
      }//6
      gm1=0;
      GM1[gm1]=JS0[0][0];  
      JS0[k0][1]=Bars1-1;  
    for( iq=1; iq<=k0; iq++)
     {//13    
      m=JS0[iq][1]-JS0[iq-1][1];
     if (m==0)
      m=1;
      Mt=(JS0[iq][0]-JS0[iq-1][0])/m;
    for( jm=0; jm<m; jm++) 
     {//14
      gm1++;
      GM1[gm1]=GM1[gm1-1]+Mt;    
     }//14 
     }//13 
     gm2=0;
      GM3[gm2]=JS1[0][0]; 
      JS1[k1][1]=Bars1-1;   
    for( iq=1; iq<=k1; iq++)
     {//13    
      m=JS1[iq][1]-JS1[iq-1][1];
     if (m==0)
      m=1;
      Mt=(JS1[iq][0]-JS1[iq-1][0])/m;
    for( jm=0; jm<m; jm++) 
     {//14
      gm2++;
      GM3[gm2]=GM3[gm2-1]+Mt;    
     }//14 
     }//13 
    for(j=0; j<=gm1; j++)
      GM2[j]=0.5*GM1[j]+0.5*GM3[j];
      
      Ex0=GM1[gm1]+4*PIP[1]/5;Ex1=JS0[k0-1][0]+4*PIP[1]/5;
      Ex4=GM3[gm2]-4*PIP[1]/5;Ex5=JS1[k1-1][0]-4*PIP[1]/5;
      Ex2=GM2[gm1];
       m=gm1;
      if (GM2[gm1]>GM2[gm1-1])
        while (GM2[m]>GM2[m-1])
         m--;
      else if (GM2[gm1]<GM2[gm1-1])
        while (GM2[m]<GM2[m-1])
         m--;
      Ex3=GM2[m];  

      GlobalVariableSet(NameGlobalVariableUpper_0, Ex0);
      GlobalVariableSet(NameGlobalVariableUpper_1, Ex1);
      GlobalVariableSet(NameGlobalVariableMedium_0, Ex2);
      GlobalVariableSet(NameGlobalVariableMedium_1, Ex3);
      GlobalVariableSet(NameGlobalVariableLower_0, Ex4);
      GlobalVariableSet(NameGlobalVariableLower_1, Ex5); 
      Upper_0=GlobalVariableGet(NameGlobalVariableUpper_0);
      Upper_1=GlobalVariableGet(NameGlobalVariableUpper_1);
      Medium_0=GlobalVariableGet(NameGlobalVariableMedium_0);
      Medium_1=GlobalVariableGet(NameGlobalVariableMedium_1);
      Lower_0=GlobalVariableGet(NameGlobalVariableLower_0);
      Lower_1=GlobalVariableGet(NameGlobalVariableLower_1);
        m=gm1-LengthSample;
      for (i=0; i<LengthSample; i++)
       {//
        GV[i][0]=GM1[i+m+1]+4*PIP[1]/5;
        GV[i][1]=GM2[i+m+1];
       }//
      m=gm2-LengthSample;
      for (i=0; i<LengthSample; i++)
        GV[i][2]=GM3[i+m+1]-4*PIP[1]/5;

    for(j=0; j<LengthSample; j++)
     {//    
      ExtMapBuffer1[LengthSample-j]=GV[j][0];
      ExtMapBuffer2[LengthSample-j]=GV[j][1];
      ExtMapBuffer3[LengthSample-j]=GV[j][2];
     }// 

    if (SaveFileData>0) 
      handle=FileOpen(FileNameData,FILE_CSV|FILE_WRITE,',');
    if (handle>0)
     {//6  
    for(i=0; i<LengthSample; i++)
     {//7
    if (Subscripting_MT4==0) 
     {//
      MS[0]=GV[i][0];
      MS[1]=GV[i][1];
      MS[2]=GV[i][2];
     }// 
    else if (Subscripting_MT4==1) 
     {//
      MS[0]=GV[LengthSample-i-1][0]; 
      MS[1]=GV[LengthSample-i-1][1];
      MS[2]=GV[LengthSample-i-1][2];
     }// 
      FileWrite(handle,MS[0],MS[1],MS[2]);
     }//7 
      FileClose(handle);
     }//6
    
      mc0++;
  
 Comment("Indicator Channel - creator K.Piligrimm <piligrimm_fx@mail.ru>", "\n","LengthSample"," ","= ",LengthSample,"  ","Threshold"," ","= ",Threshold,"  ","AmountRunning"," ","= ",mc0);
     
//----K
   return(0);

  

     }//1
//+------------------------------------------------------------------+